\section{Face System}\label{sec:face}

\textit{Face} is the generalization of network interface.
Similar to a physical network interface, packets can be sent and received on a face.
A face is more general than a network interface. It could be:
\begin{compactitem}
\item a physical network interface to communicate on a physical link
\item an overlay communication channel between NFD and a remote node
\item an inter-process communication channel between NFD and a local application
\end{compactitem}

The face abstraction provides a best-effort delivery service for NDN network layer packets.
Forwarding can send and receive Interests, Data, and Nacks through faces.
The face then handles the underlying communication mechanisms (e.g. sockets), and hides the differences of underlying protocols from forwarding.

Section~\ref{sec:face-face} introduces the semantics of face, how it's used by forwarding, and its internal structure consisting of transport (Section~\ref{sec:face-transport}) and link service (Section~\ref{sec:face-ls}).
Section~\ref{sec:face-org} describes how faces are created and organized.
Section~\ref{sec:face-ndnlp} introduces NDN Link Protocol (NDNLPv2), a link adaptation protocol implemented in face system.


\subsection{Face}\label{sec:face-face}

NFD, as a network forwarder, moves packets between network interfaces.
NFD can communicate on not only physical network interfaces, but also on a variety of other communication channels, such as overlay tunnels over TCP and UDP.
Therefore, we generalize ``network interface'' as ``face'', which abstracts a communication channel that NFD can use for packet forwarding.
The face abstraction (\texttt{nfd::Face} class) provides a best-effort delivery service for NDN network layer packets.
Forwarding can send and receive Interests, Data, and Nacks through faces.
The face then handles the underlying communication mechanisms (e.g. sockets), and hides the differences of underlying protocols from forwarding.

In NFD, the inter-process communication channel between NFD and a local application is also treated as a face.
This differs from traditional TCP/IP network stack, where local applications use syscalls to interact with the network stack, while network packets exist on the wire only.
NFD is able to communicate with a local application via a face, because the network layer packet format is same as the packets on the wire.
Having an unified face abstraction for both local application and remote hosts simplifies NFD architecture.

\paragraph{How forwarding uses faces?}

The \texttt{FaceTable} class, which is part of forwarding, keeps track of all active faces.
A newly created face is passed to \texttt{FaceTable::add}, which assigns the face a numeric FaceId for identification purpose.
After a face is closed, it's removed from the FaceTable.
Forwarding receives packets from a face by connecting to \texttt{afterReceiveInterest afterReceiveData afterReceiveNack} signals, which is done in FaceTable.
Forwarding can send network layer packets via the face by calling \texttt{sendInterest sendData sendNack} methods.

\paragraph{Face attributes}

A face exposes some attributes to display its status and control its behavior.
\begin{itemize}

\item \textbf{FaceId} is a numeric ID to identify the face.
It's assigned a non-zero value by FaceTable, and cleared when a face is removed from the FaceTable.

\item \textbf{LocalUri} is a FaceUri (Section~\ref{sec:face-transport}) that represents the local endpoint.
This attribute is read-only.

\item \textbf{RemoteUri} is a FaceUri (Section~\ref{sec:face-transport}) that represents the remote endpoint.
This attribute is read-only.

\item \textbf{Scope} indicates whether the face is local for scope control purposes.
It can be either \textit{non-local} or \textit{local}.
This attribute is read-only.

\item \textbf{Persistency} controls the behavior when an error occurs in the underlying communication channel, or when the face has been idle for some time.
\begin{compactitem}
\item A \textit{on-demand} face closes if it remains idle for some time, or when an error occurs in the underlying communication channel.
\item A \textit{persistent} face remains open until it's explicitly destroyed, or when an error occurs in the underlying communication channel.
\item A \textit{permanent} face remains open until it's explicit destroyed; errors in the underlying communication channel are recovered internally.
\end{compactitem}

\item \textbf{LinkType} indicates the type of communication link.
It can be either \textit{point-to-point} or \textit{multi-access}.
This attribute is read-only.

\item \textbf{State} indicates the current availability of the face.
\begin{compactitem}
\item \textit{UP}: the face is working properly
\item \textit{DOWN}: the face is down temporarily, and is being recovered; sending packets is possible but delivery is unlikely to succeed
\item \textit{CLOSING}: the face is being closed normally
\item \textit{FAILED}: the face is being closed due to a failure
\item \textit{CLOSED}: the face has been closed
\end{compactitem}

\item \textbf{Counters} gives statictics about the count and size of Interests, Data, Nacks, and lower layer packets sent and received on the face.

\end{itemize}

\paragraph{Internal structure}
\label{sec:face-face-internal}

\begin{figure}[htbp]
\centering
\includegraphics[scale=0.5]{face-ls-transport}
\caption{Face = LinkService + Transport}
\label{fig:face-ls-transport}
\end{figure}

Internally, a face is composed of a \textbf{link service} and a \textbf{transport} (Figure~\ref{fig:face-ls-transport}).
The transport (Section~\ref{sec:face-transport}) is the lower part of a face, which wraps the underlying communication mechanism (such as sockets or libpcap handles), and exposes a best-effort TLV packet delivery service.
The link service (Section~\ref{sec:face-ls}) is the upper part of a face, which translates between network layer packets and lower layer packets, and provides additional services such as fragmentation, link failure detection, retransmission.
The link service contains a fragmenter and a reassembler to allow it to perform fragmentation and reassembly.

The face is implemented as \texttt{nfd::face::Face} class.
The Face class is designed to be non-inheritable (except for unit testing), and the link service and transport passed to its constructor fully defines its behavior.
Within the constructor, both the link service and the transport are given a pointer to each other and to the face, so that they may call into each other with lowest runtime overhead.

Received and sent packets pass through both the transport and the link service before they are passed to forwarding or are sent on the link, respectively.
When packets are received by the transport, they are passed to the link service by calling the \texttt{LinkService::receivePacket} function.
When a packet is sent through the face, it is first passed to the link service through a function specific to the packet type (\texttt{Face::sendInterest}, \texttt{Face::sendData}, or \texttt{Face::sendNack}).
Once the packet has been processed, it is passed (or, if it has been fragmented, its fragments are passed) to the transport by calling the \texttt{Transport::send} function.
Within the link service and transport, remote endpoints are identified using a remote endpoint id (\texttt{Transport::EndpointId}), which is a 64-bit unsigned integer that contains a protocol-specific unique identifier for each remote host.


\subsection{Transport}\label{sec:face-transport}

A \textbf{transport} (\texttt{nfd::face::Transport} base class) provides best-effort packet delivery service to the link service of the face.
The link service may invoke \texttt{Transport::send} to send a packet.
When a packet arrives, \texttt{LinkService::receivePacket} will be invoked.
Each packet must be a complete TLV block; the transport makes no assumption on the TLV-TYPE of this block.
In addition, each received packet is accompanied with an \texttt{EndpointId} which indicates the sender of this packet, which is useful for fragment reassembly, failure detection, and other purposes on a multi access link.

\paragraph{Transport attributes}

The transport provides LocalUri, RemoteUri, Scope, Persistency, LinkType, State attributes.
The transport also maintains lower-layer packet counters and byte counters on incoming and outgoing directions.
These attributes and counters are accessible through the face.

If a transport's persistency is set to \textit{permanent}, the transport is responsible for taking necessary actions to recover from underlying failures.
For example: a UDP transport should ignore socket errors; a TCP transport should attempt to re-establish TCP connection if the previous connection is closed.
The progress of such recovery is reflected in the State attribute.

In addition, the transport provides the following attributes for use by link service:
\begin{itemize}

\item \textbf{Mtu} indicates the maximum packet size that can be sent or received through this transport.
It can be either a positive number, or a special \texttt{MTU\_UNLIMITED} that indicates there's no limit on packet size.
This attribute is read-only.
The transport may change the value of this attribute at any time, and the link service should be prepared for such changes.

\end{itemize}

\paragraph{FaceUri}

\textbf{FaceUri} is a URI that represents the endpoint or communication channel used by a transport.
It starts with a scheme that indicates the underlying protocol (e.g. \texttt{udp4}), followed by a scheme-specific representation of the underlying address.
It's used in LocalUri and RemoteUri attributes.

The rest of this section describes each individual transport for different underlying communication mechanism, including their FaceUri format, implementation details, and feature limitations.

\subsubsection{Internal Transport}\label{sec:face-t-internal}

Internal transport (\texttt{nfd::face::InternalForwarderTransport}) is a transport that pairs with an internal client-side transport (\texttt{nfd::face::InternalClientTransport}).
Packets transmitted on the internal forwarder-side transport is received on the paired client-side transport, and vice versa.
This is mainly used to communicate with NFD management; this is also used to implement \texttt{TopologyTester} (Section \ref{sec:test-unit-helper}) for unit testing.

\subsubsection{Unix Stream Transport}\label{sec:face-t-unix}

Unix stream transport (\texttt{nfd::face::UnixStreamTransport}) is a transport that communicates on stream-oriented Unix domain sockets.

NFD listens for incoming connections via \texttt{UnixStreamChannel} at a named socket whose path is specified by \texttt{face\_system.unix.path} configuration option.
A \texttt{UnixStreamTransport} is created for each incoming connection.
NFD does not support making outgoing Unix stream connections.

The static attributes of a Unix stream transport are:

\begin{compactitem}
\item \textbf{LocalUri} unix://\textit{path} where \textit{path} is the socket path;
      e.g. \texttt{unix:///var/run/nfd.sock}
\item \textbf{RemoteUri} fd://\textit{file-descriptor} where \textit{file-descriptor} is the file descriptor of the accepted socket within NFD process;
      e.g. \texttt{fd://30}
\item \textbf{Scope} local
\item \textbf{Persistency} on-demand; other persistency settings are disallowed
\item \textbf{LinkType} point-to-point
\item \textbf{Mtu} unlimited
\end{compactitem}

\texttt{UnixStreamTransport} is derived from \texttt{StreamTransport}, a transport which is used for all stream-based transports, including Unix stream and TCP.
Most of the functionality of \texttt{UnixStreamTransport} is handled by \texttt{StreamTransport}.
As such, when a \texttt{UnixStreamTransport} receives a packet that exceeds the maximum packet size or is not valid, the transport enters a failed state and closes.

Received data is stored in a buffer.
The current amount of data in the buffer is stored.
Upon every receive, the transport processes all valid packets in the buffer.
Then, the transport copies any remaining octets to the beginning of the buffer and waits for more octets, appending the new octets to the end of the existing octets.

\subsubsection{Ethernet Transport}\label{sec:face-t-ethernet}

Ethernet transport (\texttt{nfd::face::EthernetTransport}) is a transport that communicates directly on Ethernet.

Ethernet transport currently supports multicast only.
NFD automatically creates Ethernet transports on multicast-capable network interfaces during initialization.
In \texttt{face\_system.ether} config section, a whitelist+blacklist can be specified to create Ethernet transports on a subset of available network interfaces.
Setting \texttt{face\_system.ether.mcast} to ``no'' disables Ethernet transports altogether.

The multicast group is specified on \texttt{face\_system.ether.mcast\_group} option in NFD configuration file.
All NDN hosts on the same Ethernet segment must be configured with the same multicast group in order to communicate with each other; therefore, it's recommended to keep the default multicast group setting.

The static attributes of an Ethernet transport are:

\begin{compactitem}
\item \textbf{LocalUri} dev://\textit{ifname} where \textit{ifname} is network interface name;
      e.g. \texttt{dev://eth0}
\item \textbf{RemoteUri} ethet://[\textit{ethernet-addr}] where \textit{ethernet-addr} is the multicast group;
      e.g. \texttt{ether://[01:00:5e:00:17:aa]}
\item \textbf{Scope} non-local
\item \textbf{Persistency} permanent; other persistency settings are disallowed
\item \textbf{LinkType} multi-access
\item \textbf{Mtu} MTU of the network interface
\end{compactitem}

\texttt{EthernetTransport} uses a libpcap handle to transmit and receive on an Ethernet link.
The handle is initialized by activating onto an interface.
Then, the link-layer header format is set to EN10MB and libpcap is set to only capture incoming packets.
After the handle is initialized, the transport sets a packet filter to only capture packets with the NDN type (0x8624) that are sent to the multicast address.
The use of promiscuous mode is avoided by directly adding the address to the link-layer multicast filters using SIOCADDMULTI.
However, if this fails, the interface can fall back to promiscuous mode.

The libpcap handle is integrated with Boost Asio through the async\_read\_some function by calling the pcap read functions in the read handler.
If an oversized or invalid packet is received, it is dropped.

Each Ethernet link is a broadcast medium that naturally supports multicast communication.
Although it is possible to use this broadcast medium as many point-to-point links, doing so loses NDN's native multicast benefits, and increases the workload of NFD hosts.
Therefore, we decided it is best to use Ethernet links as multi-access only, and to not support Ethernet unicast.

\subsubsection{UDP unicast Transport}\label{sec:face-t-udp}

UDP unicast transport (\texttt{nfd::face::UnicastUdpTransport}) is a transport that communicates on UDP tunnels over IPv4 or IPv6.

NFD listens for incoming datagrams via \texttt{UdpChannel} at a port number specified by the \texttt{face\_system.udp.port} configuration option.
A \texttt{UnicastUdpTransport} is created for each new remote endpoint.
NFD can also create outgoing UDP unicast Transports.

The static attributes of a UDP unicast transport are:

\begin{compactitem}
\item \textbf{LocalUri} and \textbf{RemoteUri}
      \begin{compactitem}
      \item IPv4 udp4://\textit{ip}:\textit{port} ;
            e.g. udp4://192.0.2.1:6363
      \item IPv6 udp6://\textit{ip}:\textit{port} where \textit{ip} is in lower case and enclosed by square brackets;
            e.g. udp6://[2001:db8::1]:6363
      \end{compactitem}
\item \textbf{Scope} non-local
\item \textbf{Persistency} on-demand for transport created from accepted socket, persistent or permanent for transport created for outgoing connection;
      changing persistency settings is allowed in the transport, but currently forbidden in \texttt{FaceManager}
\item \textbf{LinkType} point-to-point
\item \textbf{Mtu} maximum IP length minus IP and UDP header
\end{compactitem}

\texttt{UnicastUdpTransport} is derived from \texttt{DatagramTransport}.
As such, it is created by adding an existing UDP socket to the transport.

The UDP unicast transport relies on IP fragmentation instead of fitting packets to the MTU of the underlying link.
This allows packets to traverse links with lower MTUs, as intermediate routers are able to fragment the packet as needed.
IP fragmentation is enabled by preventing the Don't Fragment (DF) flag from being set on outgoing packets.
On Linux, this is done by disabling PMTU discovery.

When the transport receives a packet that is too large or is incomplete, the packet is dropped.
UDP unicast transports with an on demand persistency will time out if a non-zero idle timeout is set.

UDP unicast transports will fail on an ICMP error, unless they have a permanent persistency.
However, when choosing permanent persistency, note that there are no UP/DOWN transitions, requiring the use of a strategy that tries multiple faces.

\subsubsection{UDP multicast Transport}\label{sec:face-t-udp-mcast}

UDP multicast transport (\texttt{nfd::face::MulticastUdpTransport}) is a transport that communicates on a UDP multicast group.

NFD automatically creates UDP multicast transports on multicast-capable network interfaces during initialization.
In \texttt{face\_system.udp} config section, a whitelist+blacklist can be specified to create UDP multicast transports on a subset of available network interfaces.
Setting \texttt{face\_system.udp.mcast} to ``no'' disables UDP multicast transports altogether.

UDP multicast transport currently only supports IPv4 multicast over a single hop.
Since UDP multicast communication is only supported over a single hop and almost all platforms support IPv4 multicast, there is no use case for IPv6 multicast and so it is not supported.
The multicast group and port number are specified on \texttt{face\_system.udp.mcast\_group} and \texttt{face\_system.udp.mcast\_port} options in NFD configuration file.
All NDN hosts on the same IP subnet must be configured with the same multicast group in order to communicate with each other; therefore, it's recommended to keep the default multicast group setting.

The static attributes of a UDP multicast transport are:

\begin{compactitem}
\item \textbf{LocalUri} udp4://\textit{ip}:\textit{port} ;
            e.g. udp4://192.0.2.1:56363
\item \textbf{RemoteUri} udp4://\textit{ip}:\textit{port} ;
            e.g. udp4://224.0.23.170:56363
\item \textbf{Scope} non-local
\item \textbf{Persistency} permanent
\item \textbf{LinkType} multi-access
\item \textbf{Mtu} maximum IP length minus IP and UDP header
\end{compactitem}

\texttt{MulticastUdpTransport} is derived from \texttt{DatagramTransport}.
The transport uses two separate sockets, one for sending and one for receiving.
These functions are split between the sockets to prevent sent packets from being looped back to the sending socket.

\subsubsection{TCP Transport}\label{sec:face-t-tcp}

TCP transport (\texttt{nfd::face::TcpTransport}) is a transport that communicates on TCP tunnels over IPv4 or IPv6.

NFD listens for incoming connections via \texttt{TcpChannel} at a port number specified by \texttt{face\_system.tcp.port} configuration option.
A \texttt{TcpTransport} is created for each incoming connection.
NFD can also make outgoing TCP connections.

The static attributes of a TCP transport are:

\begin{compactitem}
\item \textbf{LocalUri} and \textbf{RemoteUri}
      \begin{compactitem}
      \item IPv4 tcp4://\textit{ip}:\textit{port} ;
            e.g. tcp4://192.0.2.1:6363
      \item IPv6 tcp6://\textit{ip}:\textit{port} where \textit{ip} is in lower case and enclosed by square brackets;
            e.g. tcp6://[2001:db8::1]:6363
      \end{compactitem}
\item \textbf{Scope} local if remote endpoint has loopback IP, non-local otherwise
\item \textbf{Persistency} on-demand for transport created from accepted socket, persistent or permanent for transport created for outgoing connection;
      changing between persistency settings is allowed
\item \textbf{LinkType} point-to-point
\item \textbf{Mtu} unlimited
\end{compactitem}

Like \texttt{UnixStreamTransport}, \texttt{TcpTransport} is derived from \texttt{StreamTransport}, and thus its other specifics can be found in the \texttt{UnixStreamTransport} section (section \ref{sec:face-t-unix}).

\subsubsection{WebSocket Transport}\label{sec:face-t-ws}

WebSocket implements a message-based protocol on top of TCP for reliability.
WebSocket is the protocol used by many web applications to maintain a long connection to remote hosts.
It is used by NDN.JS client library to establish connections between browsers and NDN forwarders.

NFD listens for incoming WebSocket connections via \texttt{WebSocketChannel} at a port number specified by \texttt{face\_system.websocket.port} configuration option.
The channel listens over unencrypted HTTP and at the root path (i.e. \texttt{ws://<ip>:<port>/}); you may deploy a frontend proxy to enable TLS encryption or change the listener path (\texttt{wss://<ip>:<port>/<path>}).
A \texttt{WebSocketTransport} is created for each incoming connection.
NFD does not support outgoing WebSocket connections.

The static attributes of a WebSocket transport are:

\begin{compactitem}
\item \textbf{LocalUri}
      ws://\textit{ip}:\textit{port} ;
      e.g. ws://192.0.2.1:9696
           ws://[2001:db8::1]:6363
\item \textbf{RemoteUri}
      wsclient://\textit{ip}:\textit{port} ;
      e.g. ws://192.0.2.2:54420
           ws://[2001:db8::2]:54420
\item \textbf{Scope} local if remote endpoint has loopback IP, non-local otherwise
\item \textbf{Persistency} on-demand
\item \textbf{LinkType} point-to-point
\item \textbf{Mtu} unlimited
\end{compactitem}

\paragraph{WebSocket encapsulation of NDN packets}

\texttt{WebSocketTransport} expects exactly one NDN packet or LpPacket in each WebSocket frame.
Frames containing incomplete or multiple packets will be dropped and the event will be logged by NFD.
Client applications (and libraries) should not send such packets to NFD.
For example, a JavaScript client inside a web browser should always feed complete NDN packets into the \texttt{WebSocket.send()} interface.

\texttt{WebSocketTransport} is implemented using the websocketpp library.

The relationship between \texttt{WebSocketTransport} and \texttt{WebSocketChannel} is tighter than most Transport-Channel relationships.
This is because messages are delivered through the channel.

\subsubsection{Developing a New Transport}\label{sec:face-t-extend}

A new transport type can be created by first creating a new transport class that either specializes one of the transport template classes ((\texttt{StreamTransport} and \texttt{DatagramTransport}) or inherits from the \texttt{Transport} base class.
If the new transport type is inheriting directly from the \texttt{Transport} base class, then you will need to implement some virtual functions, including \texttt{beforeChangePersistency}, \texttt{doClose}, and \texttt{doSend}.
In addition, you will need to set the static properties (\texttt{LocalUri}, \texttt{RemoteUri}, \texttt{Scope}, \texttt{Persistency}, \texttt{LinkType}, and \texttt{Mtu}) in the constructor.
When necessary, you can set the \texttt{State} of the transport and the \texttt{ExpirationTime}.

When specializing a transport template, some of the preceding tasks will be handled by the template class.
Depending upon the template, all you may need to implement is the constructor and the \texttt{beforeChangePersistency} function, in addition to any needed helper functions.
However, note that you will still need to set the static properties of the transport in the constructor.

\subsection{Link Service}\label{sec:face-ls}

A \textbf{link service} (\texttt{nfd::face::LinkService} base class) works on top of a transport and provides a best-effort network layer packet delivery service.
A link service must translate between network layer packets (Interests, Data, and Nacks) and link layer packets (TLV blocks).
In addition, additional link services may be provided, to bridge the gap between the desire of forwarding and the capabilities of the underlying transport.
For example, if the underlying transport has a Maximum Transmission Unit (MTU) limit, fragmentation and reassembly will be needed in order to send and receive network layer packets larger than MTU; if the underlying transport has a high loss rate, per-link retransmission may be enabled to reduce loss and improve performance.

\subsubsection{Generic Link Service}\label{sec:face-ls-generic}

\textbf{Generic link service} (\texttt{nfd::face::GenericLinkService}) is the default service in NFD.
Its link layer packet format is NDNLPv2 \cite{NDNLPv2}.

As of NFD 0.4.0, the following features are implemented:

\begin{enumerate}
\item
encoding and decoding of Interest, Data, and Nack

Interests, Data, and Nack are now encapsuled in LpPackets (the Generic Link Service only supports one network layer packet or fragment per LpPacket).
LpPackets contain header fields and a fragment.
This allows hop-by-hop information to be separated from ICN information.
\item
fragmentation and reassembly (indexed fragmentation)

Interests and Data can be fragmented and reassembled hop-by-hop to allow for the traversal of links with different MTUs.
\item
consumer controlled forwarding (NextHopFaceId field)

The NextHopFaceId field enables the consumer to specify the face that an Interest should be sent out of on a connected forwarder.
\item
local cache policy (CachePolicy field)

The CachePolicy field enables a producer to specify the policy under which a Data should be cached (or not cached, depending upon the policy).
\item
incoming face indication (IncomingFaceId field)

The IncomingFaceId field can be attached to an LpPacket to inform local applications about the face on which the packet was received.
\end{enumerate}

Other planned features include:

\begin{enumerate}
\item
failure detection (similar to BFD \cite{rfc5880})
\item
link reliability improvement (repeat request, similar to ARQ \cite{rfc5401})
\end{enumerate}

What services are enabled depends upon the type of transport:\\

\begin{tabular}{l || l | l}
& Fragmentation & Local Fields (NextHopFaceId, CachePolicy, IncomingFaceId) \\ \hline \hline
Internal & No & Yes \\ \hline
UnixStream & No & No* \\ \hline
Ethernet & Yes & No \\ \hline
UnicastUdp & Yes & No \\ \hline
MulticastUdp & Yes & No \\ \hline
Tcp & No & No* \\ \hline
WebSocket & No & No
\end{tabular}\\

* Local fields can be enabled on these transport types when they have a local scope.
They can be enabled through the \texttt{enableLocalControl} management command (see section \ref{sec:mgmt-face}).

If fragmentation is enabled and a link has a limited MTU, the link service submits the network layer packet encapsulated in a link layer packet to the fragmenter.
The specific implementation of the fragmenter is discussed in a separate section below.
The link service hands each fragment off to the transport for transmission.
If fragmentation is not enabled or the link has an unlimited MTU, a sequence is assigned to the packet and it is passed to the transport for transmission.

When a link layer packet is received on the other end, it is passed from the transport to the link service.
If fragmentation is not enabled on the receiving link service, the received packet is checked for \texttt{FragIndex} and \texttt{FragCount} fields and dropped if it contains them.
The packet is then given to the reassembler, which returns a reassembled packet, but only if the received fragment completed it.
The reassembled packet is then decoded and passed up to the forwarding.
Otherwise, the received fragment is not processed further.

\paragraph{Packet Fragmentation and Reassembly in the Generic Link Service}
\label{sec:face-ls-generic-fragmentation}
The Generic Link Service uses indexed fragmentation (described in further detail in section \ref{sec:face-ndnlp}).
The sending link service has a fragmenter.
The fragmenter returns a vector of fragments encapsulted in link layer packets.
If the size of the packet is less than the MTU, the fragmenter returns a vector containing only one packet.
The link service assigns each fragment a consecutive Sequence number and, if there is more than one fragment, inserts a \texttt{FragIndex} and \texttt{FragCount} field into each.
The \texttt{FragIndex} is the 0-based index of the fragment in relation to the network layer packet and the \texttt{FragCount} is the total number of fragments produced from the packet.

The receiving link service has a reassembler.
The reassembler keeps track of received fragments in a map with a key based upon the remote endpoint id (see "Face - Internal Structure" - \ref{sec:face-face-internal}) and the Sequence of the first fragment in the packet.
It returns the reassembled packet if it is complete.
The reassembler also manages timeouts of incomplete packets, setting the drop timer when the first fragment is received.
Upon receiving a new fragment for a packet, the drop timer for that packet is reset.

\begin{figure}[htbp]
\centering
\includegraphics[scale=0.75]{linkservice-internal}
\caption{GenericLinkService Internal Structure}
\label{fig:linkservice-internal}
\end{figure}

\subsubsection{Vehicular Link Service}\label{sec:face-ls-vehicular}

\textbf{Vehicular link service} is a planned feature to implement a link service suitable for vehicular networks.

\subsubsection{Developing a New Link Service}\label{sec:face-ls-extend}

The link service can provide many services to the face, so a new link service needs to handle a number of tasks.
At the minimum, a link service must encode outgoing and decode incoming Interests, Data, and Nacks.
Depending on the intended use of the new link service, it may also be necessary to implement services like fragmentation and reassembly, local fields, and sequence number assignment, in addition to any other needed services.

\subsection{\texttt{FaceSystem}, \texttt{ProtocolFactory}, and \texttt{Channel} Classes}\label{sec:face-org}

\begin{figure}[htbp]
\centering
\includegraphics[scale=1.0,angle=270]{face-interactions}
\caption{FaceManager, Channel, ProtocolFactory, and Face interactions}
\label{fig:face-interactions}
\end{figure}

The face system is organized as a \texttt{FaceSystem}---\texttt{ProtocolFactory}---\texttt{Channel}---\texttt{Face} hierarchy.
The \texttt{FaceSystem} class is the entry point of the face system, which owns \texttt{ProtocolFactory} instances.
Each \texttt{ProtocolFactory} subclass owns unicast \texttt{Channel}s and multicast faces of a particular underlying protocol.
The \texttt{Channel} represents a local endpoint of a particular underlying protocol, and owns unicast faces bound to this local endpoint.

\subsubsection{Initialization}\label{sec:face-config}

The face system has a two-step initialization process.
First, all available \texttt{ProtocolFactory} types make themselves known to the \texttt{FaceSystem} class using \texttt{NFD\_REGISTER\_PROTOCOL\_FACTORY} macro, so that they are instantiated by \texttt{FaceSystem} constructor.
Second, \texttt{FaceSystem} receives the \texttt{face\_system} config section from the configuration parser (Section~\ref{sec:core-config}), and passes the necessary parameters to the available protocol factories, which in turn can initialize channels and faces.

Each \texttt{ProtocolFactory} subclass has a ``factory id'', and must override the \texttt{processConfig} method which will receive \texttt{face\_system.}\textit{factory-id} config section.
\texttt{FaceSystem::processConfig} loops through all \texttt{ProtocolFactory} instances, and invokes \texttt{processConfig} with the relevant subsection.

Each \texttt{ProtocolFactory} subclass can define its own config options under \texttt{face\_system.}\textit{factory-id} section.
Depending on the capability of the protocol factory and the characteristics of the underlying protocol, this may include enable flags, port numbers, timeout values, and so on.
Additionally, a \texttt{ProtocolFactory} subclass can define the behavior when its config section is omitted; typically, the corresponding protocol would be disabled in this situation.

\texttt{ProtocolFactory::processConfig} is not only used during the first initialization, but also invoked during a configuration reload (Section~\ref{sec:core-config-reload}).
In order to give the protocol factory an opportunity to de-initialize itself, \texttt{ProtocolFactory::processConfig} is invoked even if \texttt{face\_system.}\textit{factory-id} config section is omitted.
However, in current implementation, not all protocol factories fully support configuration reloads: they might keep the initial configuration, or become only partially disabled, in case the config section is omitted.

\subsubsection{Inside a ProtocolFactory}\label{sec:face-factory}

A protocol factory manages the channels (unicast) and multicast faces of a particular protocol type.
Subclasses of \textbf{ProtocolFactory} need to implement the \texttt{createFace} and \texttt{getChannels} virtual functions.
Optionally, the \texttt{createChannel}, \texttt{createMulticastFace}, and \texttt{getMulticastFaces} functions can be implemented, in addition to any protocol-specific functions.

A channel listens for and handles incoming unicast connections and starts outgoing unicast connections for a specific local endpoint.
Faces are created upon the success of either of these actions.
Channels are created by protocol factories when the \texttt{createChannel} function is called.
Upon creation of a new face, either incoming or outgoing, the \texttt{FaceCreatedCallback} specified to the \texttt{listen} function is called.
If creation of the face failed, then the \texttt{FaceCreationFailedCallback} (also specified to \texttt{listen}) is called.
Ownership of the listening socket (or in the case of WebSocket, the WebSocket server handle) lies with the individual channel.
Sockets connected to remote endpoints are owned by the transport associated with the relevant face, except in the case of WebSocket, where all faces use the same server handle.
Note that there are no Ethernet channels, as Ethernet links in NFD are multicast only.

\subsubsection{Outgoing Unicast Face Creation}\label{sec:face-create-out}

Most outgoing faces are created by the \texttt{FaceManager} (Section~\ref{sec:mgmt-face}) in response to a \texttt{faces/create} command.
The parameters to that command includes the remote FaceUri (Section~\ref{sec:face-transport}).

When a \texttt{ProtocolFactory} instance is initialized, its \texttt{ProtocolFactory::processConfig} method should declare which FaceUri schemes, if any, can be used for outgoing face creation on this \texttt{ProtocolFactory} instance, by populating the \texttt{ProtocolFactory::providedSchemes} container.
When the \texttt{FaceManager} receives a \texttt{faces/create} command, the scheme portion of the remote FaceUri is used to find an appropriate \texttt{ProtocolFactory} instance.
\texttt{ProtocolFactory::createFace} is then invoked on the instance.

Each \texttt{ProtocolFactory} subclass can define its own requirements on what FaceUris are acceptable.
Typically, the FaceUri is required to be in \textit{canonical} form.
This eliminates the need to perform DNS resolution inside the NFD process, so as to reduce overhead.

Most \texttt{ProtocolFactory} subclasses organize unicast faces into \texttt{Channel}s.
When there are multiple channels in a protocol factory, it is the factory that decides which channel is to be used to create a new face.
Typically, a channel with a compatible underlying protocol and endpoint is chosen.

\subsubsection{Multicast Face Creation}

\texttt{EthernetFactory} and \texttt{UdpFactory} can create multicast faces.
In \texttt{face\_system.ether} and \texttt{face\_system.udp} config sections, there are options to enable or disable multicast faces, and a whitelist+blacklist to choose which network interfaces should have multicast faces.

When one of these config section is processed in \texttt{EthernetFactory::processConfig} and \texttt{UdpFactory::processConfig}, multicast-related config options are stored in the factory instance.
Multicast faces are then created or destroyed based on configuration and the current list of available network interfaces, as provided by the \texttt{ndn::NetworkMonitor} class.
Whenever a network interface is added, removed, or otherwise changed, a signal from \texttt{NetworkMonitor} triggers \texttt{EthernetFactory} and \texttt{UdpFactory} to reevaluate the stored configuration, and create or destroy multicast faces as necessary.

\subsection{NIC-associated Permanent Faces}\label{sec:face-nicfaces}

This is an upcoming feature.

NIC-associated permanent faces are permanent faces automatically created on, and bound to, an OS-level network interface (physical or virtual).

The \texttt{NicFaces} class coordinates all NIC-associated permanent faces.
It is configured by \texttt{face\_system.nicfaces} config section, which contains zero or more ``rules''; each rule contains a whitelist+blacklist to select network interfaces, and a remote FaceUri to which an outgoing unicast face should be created from each matching network interface.

A \texttt{ProtocolFactory} subclass can declare itself as supporting NIC-associated permanent face by adding \texttt{scheme+dev} into \texttt{ProtocolFactory::providedSchemes} container during initialization, and overriding \texttt{ProtocolFactory::doCreateNicFace}.

\subsection{NDNLP}\label{sec:face-ndnlp}

The NDN Link Protocol (version 2) provides a link protocol between the forwarding and the underlying network transmission protocols and systems (like TCP, UDP, Unix sockets, and Ethernet).
It allows for a uniform interface to the forwarding link services and provides a bridge between these services and the underlying network layers.
Through this method, the specific features and mechanisms of these underlying layers can be overlooked by the upper layers.
In addition, the link protocol provides services common to every type of link, the specific implementation of which may vary from link type to link type.
The link service also specifies a common TLV link-layer packet format.
The services currently provided by NDNLP include fragmentation and reassembly, Negative Acknowledgement (Nacks), consumer-controlled forwarding, cache policy control, and providing information about the incoming face of a packet to applications.
Features planned for the future include link failure detection (BFD) and ARQ.
These features can be individually enabled and disabled.

In NFD, the link protocol is implemented in the \textbf{LinkService}.
This link protocol replaces the previous version of the NDN Link Protocol (NDNLPv1)\cite{NDNLPv1}.\\

A description of each of the features:

\begin{itemize}
\item
fragmentation and reassembly\\

Fragmentation and reassembly is done hop-by-hop using indexed fragmentation.
Packets are fragmented and are assigned a \textbf{FragIndex} field, which indiciates their zero-based index in the fragmented packet, and a \textbf{FragCount} field, which is the total number of fragments of the packet.
All link-layer headers associated with the network-layer packet are only attached to the first fragment.
Other, unrelated link-layer headers may be attached to any fragment by "piggybacking" onto it.
The recipient uses the \textbf{FragIndex} and \textbf{FragCount} fields from each fragment to reassemble the complete packet.

\item
Negative Acknowledgement (Nacks)\\

Negative Acknowledgements are messages sent downstream to indiciate that a forwarder was unable to satisfy a particular Interest.
The relevant Interest is included with the Nack in the \textbf{Fragment} field.
The Nack itself is indicated with the \textbf{Nack} header field in the packet.

The Nack can optionally include a \textbf{NackReason} field (under the \textbf{Nack} field) to indicate why the forwarder was unable to satisfy the Interest.
These reasons include congestion on the link, a duplicate Nonce being detected, and no route matching the Interest.

\item
consumer-controlled forwarding\\

Consumer-controlled forwarding allows an application to specify which face an outgoing Interest should be sent on.
It is indicated with the \textbf{NextHopFaceId} header, which includes the ID of the face on the local forwarder that the Interest should be sent out of.

\item
cache policy control\\

Through cache policy control, a producer can indicate how its Data should be cached (or not cached).
This is done using the \textbf{CachePolicy} header, which contains the \textbf{CachePolicyType} field.
The non-negative integer contained in this inner field is the indication of which cache policy this application wishes downstream forwarders to follow.

\item
incoming face indication\\

A forwarder can inform an application of the face on which a particular packet was received by attaching the \textbf{IncomingFaceId} header to it.
This field contains the face ID of the face on the forwarder that the packet was received on.
\end{itemize}
